Main Page Class Hierarchy Alphabetical List Compound List File List Compound Members File Members Related Pages

# ACE_Auto_IncDec Class Template Reference

This class automatically increments and decrements a parameterized counter. More...

`#include <Auto_IncDec_T.h>`

List of all members.

## Public Methods
| ACE_Auto_IncDec (ACE_SAFELY_INCREMENTABLE_DECREMENTABLE &counter)
| Implicitly increment the counter.
| ~ACE_Auto_IncDec (void)
| Implicitly decrement the counter.
void | dump (void) const
| Dump the state of an object.
## Protected Attributes
ACE_SAFELY_INCREMENTABLE_DECREMENTABLE& | counter_
| Reference to the counter we're incrementing/decrementing.
## Private Methods
void | operator= (const ACE_Auto_IncDec<ACE_SAFELY_INCREMENTABLE_DECREMENTABLE> &)
| ACE_Auto_IncDec (const ACE_Auto_IncDec<ACE_SAFELY_INCREMENTABLE_DECREMENTABLE> &)

## Detailed Description

### template<class ACE_SAFELY_INCREMENTABLE_DECREMENTABLE> template class ACE_Auto_IncDec

This class automatically increments and decrements a parameterized counter.

This data structure is meant to be used within a method, function, or scope. The actual parameter given for the template parameter must provide at least opertaors ++ and --.

## Constructor & Destructor Documentation

template<classACE_SAFELY_INCREMENTABLE_DECREMENTABLE>
ACE_INLINE ACE_Auto_IncDec< ACE_SAFELY_INCREMENTABLE_DECREMENTABLE >::ACE_Auto_IncDec<ACE_SAFELY_INCREMENTABLE_DECREMENTABLE> ( | ACE_SAFELY_INCREMENTABLE_DECREMENTABLE & counter )

| Implicitly increment the counter.

template<classACE_SAFELY_INCREMENTABLE_DECREMENTABLE>
ACE_INLINE ACE_Auto_IncDec< ACE_SAFELY_INCREMENTABLE_DECREMENTABLE >::~ACE_Auto_IncDec<ACE_SAFELY_INCREMENTABLE_DECREMENTABLE> ( | void )

| Implicitly decrement the counter.

template<classACE_SAFELY_INCREMENTABLE_DECREMENTABLE>
ACE_Auto_IncDec<ACE_SAFELY_INCREMENTABLE_DECREMENTABLE>::ACE_Auto_IncDec<ACE_SAFELY_INCREMENTABLE_DECREMENTABLE> ( | const ACE_Auto_IncDec< ACE_SAFELY_INCREMENTABLE_DECREMENTABLE >& )`[private]`

## Member Function Documentation

template<classACE_SAFELY_INCREMENTABLE_DECREMENTABLE>
void ACE_Auto_IncDec<ACE_SAFELY_INCREMENTABLE_DECREMENTABLE>::dump ( | void ) const

| Dump the state of an object.

template<classACE_SAFELY_INCREMENTABLE_DECREMENTABLE>
void ACE_Auto_IncDec<ACE_SAFELY_INCREMENTABLE_DECREMENTABLE>::operator= ( | const ACE_Auto_IncDec< ACE_SAFELY_INCREMENTABLE_DECREMENTABLE >& )`[private]`

## Member Data Documentation

template<classACE_SAFELY_INCREMENTABLE_DECREMENTABLE>
ACE_SAFELY_INCREMENTABLE_DECREMENTABLE & ACE_Auto_IncDec<ACE_SAFELY_INCREMENTABLE_DECREMENTABLE>::counter_`[protected]`

| Reference to the counter we're incrementing/decrementing.

The documentation for this class was generated from the following files:

- Auto_IncDec_T.h
- Auto_IncDec_T.i